# BoundaryCondition.py -- Pamhyr
# Copyright (C) 2023-2026  INRAE
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.

# -*- coding: utf-8 -*-

import logging

from tools import (
    trace, timer,
    old_pamhyr_date_to_timestamp,
    date_iso_to_timestamp,
    date_dmy_to_timestamp,
)

from Model.Tools.PamhyrDB import SQLSubModel
from Model.Except import NotImplementedMethodeError
from Model.Scenario import Scenario

logger = logging.getLogger()


class Data(SQLSubModel):
    _sub_classes = []

    def __init__(self, data0, data1,
                 id: int = -1,
                 types=[float, float],
                 status=None,
                 owner_scenario=-1):
        super(Data, self).__init__(
            id=id, status=status,
            owner_scenario=owner_scenario
        )

        self._types = types
        self._data = [data0, data1]

    @classmethod
    def _db_create(cls, execute, ext=""):
        execute(f"""
          CREATE TABLE boundary_condition_data{ext}(
            {cls.create_db_add_pamhyr_id()},
            deleted BOOLEAN NOT NULL DEFAULT FALSE,
            ind INTEGER NOT NULL,
            data0 TEXT NOT NULL,
            data1 TEXT NOT NULL,
            bc INTEGER,
            {Scenario.create_db_add_scenario()},
            {Scenario.create_db_add_scenario_fk()},
            FOREIGN KEY(bc) REFERENCES boundary_condition(pamhyr_id),
            PRIMARY KEY(pamhyr_id, scenario)
          )
        """)

        return cls._create_submodel(execute)

    @classmethod
    def _db_update(cls, execute, version, data=None):
        major, minor, release = version.strip().split(".")

        if major == "0" and int(minor) < 1:
            cls._db_update_to_0_2_0(execute, data)

        if major == "0" and minor == "1":
            if int(release) < 2:
                execute(
                    "ALTER TABLE boundary_condition_data " +
                    "ADD COLUMN deleted BOOLEAN NOT NULL DEFAULT FALSE"
                )

        return cls._update_submodel(execute, version, data)

    @classmethod
    def _db_update_to_0_2_0(cls, execute, data):
        table = "boundary_condition_data"
        bcs = data['id2pid']['boundary_condition']

        cls.update_db_add_pamhyr_id(
            execute, table,
            data=data
        )
        Scenario.update_db_add_scenario(execute, table)

        cls._db_create(execute, ext="_tmp")
        execute(
            f"INSERT INTO {table}_tmp " +
            "(pamhyr_id, ind, data0, data1, bc, scenario) " +
            "SELECT pamhyr_id, ind, data0, data1, bc, scenario " +
            f"FROM {table}"
        )

        execute(f"DROP TABLE {table}")
        execute(f"ALTER TABLE {table}_tmp RENAME TO {table}")

        cls._db_update_to_0_2_0_set_bc_pid(execute, table, bcs)

    @classmethod
    def _db_update_to_0_2_0_set_bc_pid(cls, execute, table, bcs):
        els = execute(
            f"SELECT pamhyr_id, bc FROM {table}"
        )

        for row in els:
            it = iter(row)
            pid = next(it)
            bc_id = next(it)

            execute(
                f"UPDATE {table} " +
                f"SET bc = {bcs[bc_id]} " +
                f"WHERE pamhyr_id = {pid}"
            )

    @classmethod
    def _db_load(cls, execute, data=None):
        new = []
        bc = data["bc"]
        scenario = data["scenario"]
        loaded = data['loaded_pid']

        if scenario is None:
            return new

        values = execute(
            "SELECT pamhyr_id, deleted, ind, " +
            "data0, data1, scenario " +
            "FROM boundary_condition_data " +
            f"WHERE bc = {bc._pamhyr_id} " +
            f"AND scenario = {scenario.id} " +
            f"AND pamhyr_id NOT IN ({', '.join(map(str, loaded))}) " +
            "ORDER BY ind ASC"
        )

        for v in values:
            it = iter(v)

            pid = next(it)
            deleted = (next(it) == 1)
            ind = next(it)
            data0 = bc._types[0](next(it))
            data1 = bc._types[1](next(it))
            owner_scenario = next(it)

            nd = cls(
                data0, data1,
                id=pid,
                types=bc._types,
                status=data['status'],
                owner_scenario=owner_scenario
            )
            if deleted:
                nd.set_as_deleted()

            loaded.add(pid)
            new.append(nd)

        data["scenario"] = scenario.parent
        new += cls._db_load(execute, data)
        data["scenario"] = scenario

        return new

    def _db_save(self, execute, data=None):
        if not self.must_be_saved():
            return True

        pid = self._pamhyr_id
        ind = data["ind"]
        data0 = self._db_format(str(self[0]))
        data1 = self._db_format(str(self[1]))
        bc = data["bc"]

        execute(
            "INSERT INTO " +
            "boundary_condition_data(pamhyr_id, deleted, ind, " +
            "data0, data1, bc, scenario) " +
            f"VALUES (" +
            f"{pid}, {self._db_format(self.is_deleted())}, " +
            f"{ind}, '{self._db_format(data0)}', {self._db_format(data1)}, " +
            f"{bc._pamhyr_id}, {self._status.scenario_id}" +
            ")"
        )

        return True

    def __getitem__(self, key):
        return self._types[key](self._data[key])

    def __setitem__(self, key, value):
        self._data[key] = self._types[key](value)


class BoundaryCondition(SQLSubModel):
    _sub_classes = [Data]

    def __init__(self, id: int = -1,
                 name: str = "",
                 status=None,
                 owner_scenario=-1):
        super(BoundaryCondition, self).__init__(
            id=id, status=status,
            owner_scenario=owner_scenario
        )

        self._name = name
        self._type = ""
        self._node = None
        self._data = []
        self._header = []
        self._types = [float, float]

    @classmethod
    def _db_create(cls, execute, ext=""):
        execute(f"""
          CREATE TABLE boundary_condition{ext}(
            {cls.create_db_add_pamhyr_id()},
            deleted BOOLEAN NOT NULL DEFAULT FALSE,
            name TEXT NOT NULL,
            type TEXT NOT NULL,
            tab TEXT NOT NULL,
            node INTEGER,
            d50 REAL DEFAULT 0.002,
            sigma REAL DEFAULT 1,
            {Scenario.create_db_add_scenario()},
            {Scenario.create_db_add_scenario_fk()},
            FOREIGN KEY(node) REFERENCES river_node(pamhyr_id),
            PRIMARY KEY(pamhyr_id, scenario)
          )
        """)

        if ext == "_tmp":
            return True

        return cls._create_submodel(execute)

    @classmethod
    def _db_update(cls, execute, version, data=None):
        major, minor, release = version.strip().split(".")

        if major == minor == "0":
            cls._db_update_to_0_2_0(execute, data)

        if major == "0" and minor == "1":
            if int(release) < 2:
                execute(
                    "ALTER TABLE friction " +
                    "ADD COLUMN deleted BOOLEAN NOT NULL DEFAULT FALSE"
                )

        if major == "0" and int(minor) <= 2:
            if int(release) < 4:
                execute(
                    "ALTER TABLE boundary_condition " +
                    "ADD COLUMN d50 REAL DEFAULT 0.002"
                )
                execute(
                    "ALTER TABLE boundary_condition " +
                    "ADD COLUMN sigma REAL DEFAULT 1"
                )

        return cls._update_submodel(execute, version, data)

    @classmethod
    def _db_update_to_0_2_0(cls, execute, data):
        table = "boundary_condition"
        nodes = data['id2pid']['river_node']

        cls.update_db_add_pamhyr_id(execute, table, data)
        Scenario.update_db_add_scenario(execute, table)

        cls._db_create(execute, ext="_tmp")

        # Copy table
        execute(
            f"INSERT INTO {table}_tmp " +
            f"(pamhyr_id, name, type, tab, node, scenario) " +
            "SELECT pamhyr_id, name, type, tab, node, scenario " +
            f"FROM {table}"
        )

        execute(f"DROP TABLE {table}")
        execute(f"ALTER TABLE {table}_tmp RENAME TO {table}")

        cls._db_update_to_0_2_0_set_node_pid(execute, table, nodes)

    @classmethod
    def _get_ctor_from_type(cls, t):
        from Model.BoundaryCondition.BoundaryConditionTypes import (
            NotDefined, PonctualContribution,
            TimeOverZ, TimeOverDischarge, ZOverDischarge,
            Solid,
        )

        res = NotDefined
        if t == "PC":
            res = PonctualContribution
        elif t == "TZ":
            res = TimeOverZ
        elif t == "TD":
            res = TimeOverDischarge
        elif t == "ZD":
            res = ZOverDischarge
        elif t == "SL":
            res = Solid
        return res

    @classmethod
    def _db_load(cls, execute, data=None):
        new = []
        tab = data["tab"]
        nodes = data["nodes"]
        scenario = data["scenario"]
        loaded = data['loaded_pid']

        if scenario is None:
            return new

        table = execute(
            "SELECT pamhyr_id, deleted, name, type, node, d50, sigma, " +
            "scenario " +
            "FROM boundary_condition " +
            f"WHERE tab = '{tab}' " +
            f"AND scenario = {scenario.id} " +
            f"AND pamhyr_id NOT IN ({', '.join(map(str, loaded))}) "
        )

        for row in table:
            it = iter(row)

            pid = next(it)
            deleted = (next(it) == 1)
            name = next(it)
            t = next(it)
            node = next(it)
            d50 = next(it)
            sigma = next(it)
            owner_scenario = next(it)

            ctor = cls._get_ctor_from_type(t)

            bc = ctor(
                id=pid, name=name,
                status=data['status'],
                owner_scenario=owner_scenario
            )

            if deleted:
                bc.set_as_deleted()

            if t == "SL":
                bc.d50 = d50
                bc.sigma = sigma

            bc.node = None
            if node != -1:
                bc.node = next(filter(lambda n: n.id == node, nodes), None)

            data["bc"] = bc
            bc._data = Data._db_load(execute, data=data)

            loaded.add(pid)
            new.append(bc)

        data["scenario"] = scenario.parent
        new += cls._db_load(execute, data)
        data["scenario"] = scenario

        return new

    def _db_save(self, execute, data=None):
        if not self.must_be_saved():
            return True

        tab = data["tab"]

        execute(
            "DELETE FROM boundary_condition_data " +
            f"WHERE bc = {self._pamhyr_id} " +
            f"AND scenario = {self._status.scenario_id}"
        )

        node = -1
        if self._node is not None:
            node = self._node.id

        d50 = 0.002
        sigma = 1
        if self._type == "SL":
            d50 = self._d50
            sigma = self._sigma

        execute(
            "INSERT INTO " +
            "boundary_condition(" +
            "pamhyr_id, deleted, name, type, tab, node, d50, sigma, scenario" +
            ") " +
            "VALUES (" +
            f"{self._pamhyr_id}, {self._db_format(self.is_deleted())}, " +
            f"'{self._db_format(self._name)}', " +
            f"'{self._db_format(self._type)}', '{tab}', {node}, " +
            f"{d50}, {sigma}, " +
            f"{self._status.scenario_id}" +
            ")"
        )

        data["bc"] = self

        ind = 0
        for d in self._data:
            data["ind"] = ind

            d._db_save(execute, data)

            ind += 1

        return True

    def _data_traversal(self,
                        predicate=lambda obj, data: True,
                        modifier=lambda obj, data: None,
                        data={}):
        if predicate(self, data):
            modifier(self, data)

        for el in self._data:
            el._data_traversal(predicate, modifier, data)

    def __len__(self):
        return len(
            list(
                filter(
                    lambda el: not el.is_deleted(),
                    self._data
                )
            )
        )

    @classmethod
    def compatibility(cls):
        return ["liquid", "solid", "suspenssion"]

    @classmethod
    def time_convert(cls, data):
        if type(data) is str:
            if data.count("-") == 2:
                return date_iso_to_timestamp(data)
            if data.count("/") == 2:
                return date_dmy_to_timestamp(data)
            if data.count(":") == 3:
                return old_pamhyr_date_to_timestamp(data)
            if data.count(":") == 2:
                return old_pamhyr_date_to_timestamp("00:" + data)
            if data.count(".") == 1:
                return round(float(data))

        return int(data)

    @property
    def name(self):
        if self._name == "":
            return f"B #{self.pamhyr_id}"

        return self._name

    @name.setter
    def name(self, name):
        self._name = name
        self.modified()

    @property
    def bctype(self):
        return self._type

    @property
    def node(self):
        return self._node

    @node.setter
    def node(self, node):
        self._node = node
        self.modified()

    def has_node(self):
        return self._node is not None

    @property
    def d50(self):
        return self._d50

    @d50.setter
    def d50(self, value):
        self._d50 = float(value)
        self.modified()

    @property
    def sigma(self):
        return self._sigma

    @sigma.setter
    def sigma(self, value):
        self._sigma = float(value)
        self.modified()

    @property
    def header(self):
        return self._header.copy()

    @property
    def data(self):
        return list(
            filter(
                lambda el: not el.is_deleted(),
                self._data
            )
        )

    def get_type_column(self, column):
        if 0 <= column < 2:
            return self._types[column]
        return None

    @property
    def _default_0(self):
        return self._types[0](0)

    @property
    def _default_1(self):
        return self._types[1](0.0)

    def is_define(self):
        return self._data is not None

    def new_from_data(self, header, data):
        new_0 = self._default_0
        new_1 = self._default_1

        if len(header) != 0:
            for i in [0, 1]:
                for j in range(len(header)):
                    if self._header[i] == header[j]:
                        if i == 0:
                            new_0 = self._types[i](data[j].replace(",", "."))
                        else:
                            new_1 = self._types[i](data[j].replace(",", "."))
        else:
            new_0 = self._types[0](data[0].replace(",", "."))
            new_1 = self._types[1](data[1].replace(",", "."))

        return Data(
            new_0, new_1,
            status=self._status
        )

    def add(self, index: int):
        value = Data(
            self._default_0, self._default_1,
            status=self._status
        )
        self._data.insert(index, value)
        self.modified()
        return value

    def insert(self, index: int, value):
        if value in self._data:
            value.set_as_not_deleted()
        else:
            self._data.insert(index, value)

        self.modified()

    def hard_delete_i(self, indexes):
        self._data = list(
            map(
                lambda e: e[1],
                filter(
                    lambda e: e[0] not in indexes,
                    enumerate(self._data)
                )
            )
        )
        self.modified()

    def delete_i(self, indexes):
        list(
            map(
                lambda e: e[1].set_as_deleted(),
                filter(
                    lambda e: e[0] in indexes,
                    enumerate(self.data)
                )
            )
        )
        self.modified()

    def delete(self, els):
        for el in els:
            el.set_as_deleted()

        self.modified()

    def undelete(self, els):
        for el in els:
            el.set_as_not_deleted()

        self.modified()

    def sort(self, _reverse=False, key=None):
        if key is None:
            self._data.sort(reverse=_reverse)
        else:
            self._data.sort(reverse=_reverse, key=key)
        self.modified()

    def index(self, bc):
        self._data.index(bc)

    def get_i(self, index):
        if len(self._data) == 0:
            return None

        return self._data[index]

    def get_range(self, _range):
        lst = []
        for r in _range:
            lst.append(r)
        return lst

    def _set_i_c_v(self, index, column, value):
        v = self._data[index]
        v[column] = self._types[column](value)
        self._data[index] = v
        self.modified()

    def set_i_0(self, index: int, value):
        self._set_i_c_v(index, 0, value)

    def set_i_1(self, index: int, value):
        self._set_i_c_v(index, 1, value)

    @timer
    def convert(self, cls):
        new = cls(name=self.name, status=self._status)
        new.node = self.node

        for i, _ in enumerate(self.data):
            new.add(i)

        for i in [0, 1]:
            for j in [0, 1]:
                if self._header[i] == new.header[j]:
                    for ind, v in self.data:
                        try:
                            new._set_i_c_v(ind, j, v[i])
                        except Exception as e:
                            logger.info(e)

        return new

    def move_up(self, index):
        if index < len(self):
            next = index - 1
            d = self._data
            d[index], d[next] = d[next], d[index]
            self.modified()

    def move_down(self, index):
        if index >= 0:
            prev = index + 1
            d = self._data
            d[index], d[prev] = d[prev], d[index]
            self.modified()

    def reach(self, river):
        r = []
        if self._node is not None:
            if river is not None:
                for edge in river.edges():
                    if edge.node1.name == self._node.name:
                        r.append(edge.reach)
                    if edge.node2.name == self._node.name:
                        r.append(edge.reach)

        return r
